#include "color.h"

namespace segl {

Color::Color() {
	set(0.0f, 0.0f, 0.0f, 1.0f);
	setalpha = true;
}

Color::Color(float _r, float _g, float _b, float _a) {
	set(_r, _g, _b, _a);
}

Color::Color(const SDL_Color &c) {
	set(c.r/255.0f, c.g/255.0f, c.b/255.0f);
	setalpha = true;
}

void Color::set(float _r, float _g, float _b, float _a) {
	r = _r;
	g = _g;
	b = _b;
	a = _a;
}

SDL_Color Color::getSDLColor() {
	SDL_Color c = {(Uint8)(r*255.0f), (Uint8)(g*255.0f), (Uint8)(b*255.0f), (Uint8)(a*255.0f)};
	return c;
}

void Color::print(std::string m) {
	std::cout << m << " Color: " << r << ", " << g << ", " << b << std::endl;
}

} // namespace segl

void glColorGLC(segl::Color c) {
	if(c.setalpha) {
		glColor4f(c.r, c.g, c.b, c.a);
	} else {
		glColor3f(c.r, c.g, c.b);
	}	
}
