#ifndef __PUNKT3D_H
#define __PUNKT3D_H

#include <iostream>
#include <cmath>
#include <SDL_opengl.h>
#include "emath.h"

namespace segl {

class Punkt2D {
	public:
		Punkt2D();
		Punkt2D(float, float);
		
		float x, y;
		
		void set(float, float);
		void print(std::string="");
		float abs();
		
		void normalize();
		Punkt2D getNormalized() const;
		
		// Operatoren
		Punkt2D operator+(const Punkt2D&);
		Punkt2D operator-(const Punkt2D&);
		Punkt2D& operator+=(const Punkt2D&);
		Punkt2D& operator-=(const Punkt2D&);
		
		Punkt2D operator+(const float&);
		Punkt2D operator-(const float&);
		Punkt2D operator*(const float&);
		Punkt2D operator/(const float&);
		Punkt2D& operator+=(const float&);
		Punkt2D& operator-=(const float&);
		Punkt2D& operator*=(const float&);
		Punkt2D& operator/=(const float&);
		
		float operator*(const Punkt2D&);
		
		Punkt2D operator-();
		
		bool operator==(const Punkt2D&);
		bool operator!=(const Punkt2D&);
		
		friend Punkt2D operator+(const float&, const Punkt2D&);
		friend Punkt2D operator-(const float&, const Punkt2D&);
		friend Punkt2D operator*(const float&, const Punkt2D&);
		friend Punkt2D operator/(const float&, const Punkt2D&);
		
};


} // namespace segl

// #ifdef GLAPI
void glTexCoord2f(segl::Punkt2D);
float abs(segl::Punkt2D);

// Fixed Headers
void glTexCoordP2D(segl::Punkt2D p);
// #endif /* GLAPI */


#endif
